#!/bin/sh
#
# add_item.cgi
# this script is called from ewp.html for the Add function
# it takes the specified items and creates a new record on the
# end of the named file in the data directory
#

error()
{
	echo $*
    echo "Press the Back button now."
	exit 1
}


	eval `./qryparse`		                        # receive form data
	DATAFILE=$pagename.tab                          # $pagename set by qryparse

	echo "Content-type: text/plain"	                # tell browser type of output
	echo ""			                	            # end of header

    if [ "$pagename" = "" ] ; then                  # ensure pagename
       error "Your pagename is blank."
    fi
    
    if [ "$title" = "" ] ; then                     # ensure title
       error "Your item title is blank."
    fi

    
	if [ ! -d data ] ; then                         # if no data directory
		mkdir data		                            # try to make it
		if [ $? -ne 0 ] ; then           	        # and check for errors
			error "Cannot create data directory."
		fi
	fi

	cd data
    
    #prep newline
    NEWLINE="title=$title|tcolor=$titlecolor|desc=$descrip|url=$url"
    STDAPPND=YES
    
    if [ -e $DATAFILE ] ; then                      # check for datafile
        if grep $title $DATAFILE > /dev/null ; then # check for specific line
            sed "/$title/c\\
$NEWLINE" $DATAFILE > $DATAFILE.tmp
            STDAPPND=NO
            mv -f $DATAFILE.tmp $DATAFILE           # copy .tmp over .tab
        fi
    fi
    
    # use standard replace
    if [ "$STDAPPND" = "YES" ] ; then
        printf "title=%s|tcolor=%s|desc=%s|url=%s\n" \
		    "$title" "$titlecolor" "$descrip" "$url" >> $DATAFILE
    fi
            
	if [ $? -eq 0 ] ; then
		echo "Addition of $title was successful."
		echo "Press the Back button now."
	else
		echo "Unable to update file $DATAFILE ."
		echo "Please report to page admin."
	fi
